package com.sample.wui.jbpm;

import static org.jbpm.test.JBPMHelper.txStateName;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.ejb.Stateless;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.PersistenceUnit;
import javax.transaction.Status;
import javax.transaction.SystemException;
import javax.transaction.Transaction;

import org.drools.KnowledgeBase;
import org.drools.KnowledgeBaseFactory;
import org.drools.SystemEventListenerFactory;
import org.drools.builder.KnowledgeBuilder;
import org.drools.builder.KnowledgeBuilderError;
import org.drools.builder.KnowledgeBuilderFactory;
import org.drools.builder.ResourceType;
import org.drools.impl.EnvironmentFactory;
import org.drools.io.ResourceFactory;
import org.drools.logger.KnowledgeRuntimeLogger;
import org.drools.logger.KnowledgeRuntimeLoggerFactory;
import org.drools.marshalling.ObjectMarshallingStrategy;
import org.drools.marshalling.impl.ClassObjectMarshallingStrategyAcceptor;
import org.drools.marshalling.impl.SerializablePlaceholderResolverStrategy;
import org.drools.persistence.jpa.JPAKnowledgeService;
import org.drools.persistence.jpa.marshaller.JPAPlaceholderResolverStrategy;
import org.drools.runtime.Environment;
import org.drools.runtime.EnvironmentName;
import org.drools.runtime.KnowledgeSessionConfiguration;
import org.drools.runtime.StatefulKnowledgeSession;
import org.drools.runtime.process.ProcessInstance;
import org.jbpm.process.audit.JPAProcessInstanceDbLog;
import org.jbpm.process.audit.JPAWorkingMemoryDbLogger;
import org.jbpm.process.workitem.wsht.GenericHTWorkItemHandler;
import org.jbpm.task.Task;
import org.jbpm.task.TaskService;
import org.jbpm.task.User;
import org.jbpm.task.query.TaskSummary;
import org.jbpm.task.service.TaskServiceSession;
import org.jbpm.task.service.local.LocalTaskService;
import org.jbpm.workflow.instance.WorkflowProcessInstance;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import bitronix.tm.TransactionManagerServices;

@Stateless(name = "test")
public class GenericChageObjectTest {// extends JbpmJUnitTestCase {

	private org.jbpm.task.service.TaskService taskService;
	public static final String LOCALE = "en-UK";
	public static final String BPMN = "GenericChangeObject.bpmn";
	private GenericHTWorkItemHandler htHandler;
	
	private static final Logger log = LoggerFactory
			.getLogger(GenericChageObjectTest.class);

	@PersistenceUnit(unitName = "org.jbpm.persistence.jpa")
	private EntityManagerFactory jbpmPersistence;

	@PersistenceUnit(unitName = "org.jbpm.task")
	private EntityManagerFactory jbpmTask;

	// public GenericChageObjectTest() {
	// super(true);
	// setPersistence(true);
	// }

	public void doTest() {
		try {
			test();
		} catch (Exception e) {
			log.error(" FAIL ", e);
		}
	}

	public void test() throws Exception {

		// UserGroupCallbackManager.getInstance()
		// .setCallback(
		// new DefaultUserGroupCallbackImpl(
		// "classpath:/roles.properties"));
		StatefulKnowledgeSession ksession = createSession(BPMN);
		// "test.bpmn2");
		KnowledgeRuntimeLogger knowledgeRuntimeLogger = KnowledgeRuntimeLoggerFactory
				.newThreadedFileLogger(ksession, "test", 1000);
		// hornetQServer = new HornetQTaskServer(taskService, 5445);
		// Thread t = new Thread(hornetQServer);
		// t.start();
		// Thread.sleep(2000);
		// AsyncHornetQHTWorkItemHandler hornetQHTWorkItemHandler = new
		// AsyncHornetQHTWorkItemHandler(ksession);
		// ksession.getWorkItemManager().registerWorkItemHandler("Human Task",
		// hornetQHTWorkItemHandler);
		// start a new process instance
		htHandler = registerHumanTaskWorkItemHandler(ksession);
		// Map<String, Object> params = new HashMap<String, Object>();
		// params.put("value", "value");
		ProcessInstance pi = ksession
				.startProcess("com.sample.genericchange.bpmn");
		// "org.jenkinsci.plugins.jbpm.human", params);
		Long processInstanceId = pi.getId();

		ksession.fireAllRules();
		knowledgeRuntimeLogger.close();
		// // we can reuse the client used by the Work Item Hander.
		// TaskService taskClient = new SyncTaskServiceWrapper(new
		// AsyncHornetQTaskClient("test"));
		//
		// taskClient.connect("127.0.0.1", 5445);

		sleep(7000);

		// List<TaskSummary> tasks =
		// taskClient.getTasksAssignedAsPotentialOwner("user1", "en-UK");

		Long taskId = startTask("user1", processInstanceId);
		// List<TaskSummary> tasks = taskClient.getTask
		sleep(7000);
		// Thread.sleep(1000);
		//
		// taskClient.start(task1.getId(), "user1");
		// Task task = getLocalTaskService().getTask(taskId);

		MyWrapper wrapper = new MyWrapper();
		wrapper.setIsEdited(true);
		Map<String, Object> results = new HashMap<String, Object>();
		results.put("result", wrapper);
		resolvTask(results, "user1", taskId, ksession);
		sleep(7000);
		// ContentData contentData = ContentMarshallerHelper
		// .marshal(results, null);
		//
		// taskClient.complete(task.getId(), "user1", contentData);
		logWraper(ksession, processInstanceId);

		log.info("Task status is " + getTaskStatus(taskId));

		logWraper(ksession, processInstanceId);
		sleep(7000);
		Integer sessionId = ksession.getId();
		ksession.dispose();
		log.info("session dispose..");
		sleep(7000);
		log.info("-------------------------");
		// now I can not get variable...
		
//		--------------------------------------
//		Uncomment this code to check restore
//		--------------------------------------
/*		try {
			ksession = restoreSession(ksession, true);
		} catch (Exception e) {
			throw new IllegalStateException("cannot restore disposed session ",e);
		}
		*/		
//		--------------------------------------
		
//		--------------------------------------
//		Uncomment this code to check load
//		--------------------------------------
/*		try {
			ksession = loadSession(sessionId, BPMN);
		} catch (Exception e) {
			throw new IllegalStateException("cannot load disposed session ",e);
		}
		*/		
//		--------------------------------------
		
//		--------------------------------------
//		Uncomment this code to check get variable from new session
//		--------------------------------------
/*		try {
			ksession = createSession(BPMN);
			sleep(7000);
			logWraper(ksession, processInstanceId);
		} catch (Exception e) {
			throw new IllegalStateException("cannot get variable from new session",e);
		}
		*/		
//		--------------------------------------
		
		
//		--------------------------------------
//		comment out this code.. 
//		this is combo test... fails on transactions..
//		--------------------------------------
		try {

			ksession = restoreSession(ksession, true);
		} catch (Exception e) {
			log.error("cannot restore disposed session - try to load it");
			try {
				sleep(7000);
				ksession = loadSession(sessionId, BPMN);
			} catch (Exception e1) {
				log.error("Cannot load or restore session with id "+sessionId+" and bpmn "+BPMN);
//				create new session and try to get variable from it by getProcessInstance
				ksession = createSession(BPMN);
				sleep(7000);
				logWraper(ksession, processInstanceId);
			}
			
		}
//		--------------------------------------
		log.info("-------------------------");
		logWraper(ksession, processInstanceId);
		sleep(7000);
		// starting another HT
		taskId = startTask("approver", processInstanceId);

		Map<String, Object> results2 = new HashMap<String, Object>();
		results.put("isApproved", true);
		resolvTask(results2, "approver", taskId, ksession);
		sleep(7000);
		getLocalTaskService().disconnect();
		htHandler.dispose();
	}

	private void sleep(long milis) {
		log.info("going 2 sleep for " + milis / 1000 + "s");
		try {
			Thread.sleep(milis);
		} catch (InterruptedException e) {
			log.error("InterruptedException");
		}
	}

	public StatefulKnowledgeSession loadSession(int id, String bpmn) { 
	    KnowledgeBase kbase = createKnowledgeBase(bpmn);
	       
        final KnowledgeSessionConfiguration config = KnowledgeBaseFactory.newKnowledgeSessionConfiguration();
//        config.setOption( ClockTypeOption.get( ClockType.PSEUDO_CLOCK.getId() ) );
        
	    StatefulKnowledgeSession ksession = JPAKnowledgeService.loadStatefulKnowledgeSession(id, kbase, config, createEnvironment(jbpmPersistence));
//        KnowledgeSessionCleanup.knowledgeSessionSetLocal.get().add(ksession);
        new JPAWorkingMemoryDbLogger(ksession);
        taskService = null;
        registerHumanTaskWorkItemHandler(ksession);
        return ksession;
	}
	
	protected StatefulKnowledgeSession restoreSession(
			StatefulKnowledgeSession ksession, boolean noCache)
			throws SystemException {
		int id = ksession.getId();
		KnowledgeBase kbase = ksession.getKnowledgeBase();
		Transaction tx = TransactionManagerServices.getTransactionManager()
				.getCurrentTransaction();
		if (tx != null) {
			int txStatus = tx.getStatus();
			asserT(tx.getStatus() == Status.STATUS_NO_TRANSACTION,
					"Current transaction state is " + txStateName[txStatus]);
		}
		Environment env = null;
		if (noCache) {
			jbpmPersistence.close();
			env = EnvironmentFactory.newEnvironment();
			jbpmPersistence = Persistence
					.createEntityManagerFactory("org.jbpm.persistence.jpa");
			env.set(EnvironmentName.ENTITY_MANAGER_FACTORY, jbpmPersistence);
			env.set(EnvironmentName.TRANSACTION_MANAGER,
					TransactionManagerServices.getTransactionManager());
			JPAProcessInstanceDbLog.setEnvironment(env);
			taskService = null;
		} else {
			env = ksession.getEnvironment();
			taskService = null;
		}
		KnowledgeSessionConfiguration config = ksession
				.getSessionConfiguration();
		ksession.dispose();

		// reload knowledge session
		ksession = JPAKnowledgeService.loadStatefulKnowledgeSession(id, kbase,
				config, env);
		registerHumanTaskWorkItemHandler(ksession);
		// KnowledgeSessionCleanUp.knowledgeSessionSetLocal.get().add(ksession);
		new JPAWorkingMemoryDbLogger(ksession);
		return ksession;
	}

	private void logWraper(StatefulKnowledgeSession ksession,
			Long processInstanceId) {
		MyWrapper wrapper = ((MyWrapper) getProcessParameter(ksession,
				processInstanceId, "wrapper"));
		asserT(wrapper != null, "wrapper is null");
		log.info("is edited: " + wrapper.getIsEdited());
	}

	private Task getTask(Long taskId) {
		TaskService taskService = getLocalTaskService();
		return taskService.getTask(taskId);

	}

	public String getTaskStatus(Long taskId) {
		return getTask(taskId).getTaskData().getStatus().name();
	}

	public void resolvTask(Map<String, Object> result, String user,
			Long taskId, StatefulKnowledgeSession ksession) {

		log.info("resolv task user: " + user + " taskId: " + taskId);

		TaskService taskService = getLocalTaskService();
		// Task task = taskService.getTask(taskId);
		if (result != null) {
			log.info("result: ");
			for (String key : result.keySet()) {
				Object res = result.get(key);

				log.info("<" + key + "," + res + ">");
			}
			taskService.completeWithResults(taskId, user, result);
		} else {
			taskService.complete(taskId, user, null);
		}

		ksession.fireAllRules();

	}

	public Object getProcessParameter(StatefulKnowledgeSession ksession,
			Long processInstanceId, String key) {

		WorkflowProcessInstance workflowProcessInstance = (WorkflowProcessInstance) ksession
				.getProcessInstance(processInstanceId);
		log.info("WorkflowProcessInstance " + workflowProcessInstance);
		log.info(workflowProcessInstance != null ? " <" + key + ","
				+ workflowProcessInstance.getVariable(key) + ">"
				: " Cannot get data for key: " + key);
		return workflowProcessInstance.getVariable(key);

	}

	@SuppressWarnings({ "rawtypes", "unchecked" })
	protected TaskService getLocalTaskService() {
		if (htHandler != null) {
			return htHandler.getClient();
		}
		if (taskService == null) {
			taskService = new org.jbpm.task.service.TaskService(jbpmTask,
					SystemEventListenerFactory.getSystemEventListener());
			taskService
					.setEscalatedDeadlineHandler(MyEscalatedDeadlineHandler.getInstance());
			TaskServiceSession taskServiceSession = taskService.createSession();
			// TODO create dynamic users list..
			log.info("adding users");
			taskServiceSession.addUser(new User("approver"));
			taskServiceSession.addUser(new User("user1"));

			// Map vars = new HashMap();
			// Reader reader = new InputStreamReader(this.getClass()
			// .getResourceAsStream("LoadUsers.mvel"));
			// Map<String, User> users = (Map<String, User>)
			// org.jbpm.task.service.TaskService
			// .eval(reader, vars);
			// reader = new
			// InputStreamReader(this.getClass().getResourceAsStream(
			// "LoadGroups.mvel"));
			// Map<String, Group> groups = (Map<String, Group>)
			// org.jbpm.task.service.TaskService
			// .eval(reader, vars);
			// sTaskService.addUsersAndGroups(users, groups);

		}
		return new LocalTaskService(taskService);
		// taskservicesMap.put(processName, taskService);

	}

	protected GenericHTWorkItemHandler registerHumanTaskWorkItemHandler(
			StatefulKnowledgeSession ksession) {

		getLocalTaskService();

		MyHtWorkItemHandler workItemHandler = new MyHtWorkItemHandler(ksession);

		workItemHandler.setLocal(true);
		workItemHandler.setIpAddress("127.0.0.1");
		workItemHandler.setPort(5445);
		workItemHandler.setClient(getLocalTaskService());
		ksession.getWorkItemManager().registerWorkItemHandler("Human Task",
				workItemHandler);
		workItemHandler.connect();
		return workItemHandler;

	}

	public void startTask(Long taskId, String user) {
		log.info("Starting task - user: " + user + "  taskId: " + taskId);
		TaskService taskService = getLocalTaskService();
		taskService.start(taskId, user);
	}

	public Long startTask(String user, Long processInstanceId) {
		Task task = getTask(user, processInstanceId);
		asserT(task != null, "taski is null");
		Long taskId = task.getId();
		startTask(taskId, user);
		return taskId;
	}

	public Task getTask(String user, Long processInstanceId) {
		// assumprion user can be assing only to one task at one time - it
		// return the first math
		TaskService taskService = getLocalTaskService();
		List<TaskSummary> taskList = taskService
				.getTasksAssignedAsPotentialOwner(user, LOCALE);

		for (TaskSummary ts : taskList) {

			if (ts.getProcessInstanceId() == processInstanceId) {
				return taskService.getTask(ts.getId());
			}
		}
		log.info("Task not found user: " + user + " processInstanceId: "
				+ processInstanceId);
		return null;
	}

	private KnowledgeBase createKnowledgeBase(String bpmn) {
		KnowledgeBuilder kbuilder = KnowledgeBuilderFactory
				.newKnowledgeBuilder();

		kbuilder.add(ResourceFactory.newClassPathResource(bpmn),
				ResourceType.BPMN2);

		// Check for errors
		if (kbuilder.hasErrors()) {
			if (kbuilder.getErrors().size() > 0) {
				for (KnowledgeBuilderError error : kbuilder.getErrors()) {
					log.info(error.toString());
				}

			}
		}

		return kbuilder.newKnowledgeBase();
	}

	private static Environment createEnvironment(EntityManagerFactory emf) {
		log.info("Setup enviroment");
		Environment env = EnvironmentFactory.newEnvironment();
		env.set(EnvironmentName.ENTITY_MANAGER_FACTORY, emf);
		 env.set(EnvironmentName.TRANSACTION_MANAGER,
		 TransactionManagerServices.getTransactionManager());
			env.set(EnvironmentName.OBJECT_MARSHALLING_STRATEGIES,
					new ObjectMarshallingStrategy[] {
							new JPAPlaceholderResolverStrategy(env),
							new SerializablePlaceholderResolverStrategy(
									ClassObjectMarshallingStrategyAcceptor.DEFAULT) });
		return env;
		

	}

	private StatefulKnowledgeSession createSession(String bpmn) {

		KnowledgeBase kbase = createKnowledgeBase(bpmn);

		KnowledgeSessionConfiguration conf = KnowledgeBaseFactory
				.newKnowledgeSessionConfiguration();
		Environment env = createEnvironment(jbpmPersistence);
		log.info("Create StatefulKnowledgeSession " + bpmn);
		StatefulKnowledgeSession ksession = JPAKnowledgeService
				.newStatefulKnowledgeSession(kbase, conf, env);
		// new JPAWorkingMemoryDbLogger(ksession);
		return ksession;

	}

	private void asserT(Boolean condition, String mess) {
		if (!condition) {
			throw new IllegalStateException(mess);
		}
	}
}
